/*
 File: esc_seq.h
 Date and Time: Fri Jan 30 18:55:11 2015 
*/
#ifndef __esc_seq_h__
#define __esc_seq_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "stdlib.h"
  
extern yacco2::Thread_entry ITH_esc_seq;

extern yacco2::State S1_Cesc_seq;
namespace NS_esc_seq {
yacco2::THR _YACCO2_CALL_TYPE
TH_esc_seq(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_esc_seq(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[17];
};
class Cesc_seq: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Resc_seq_ = 569//start_of_rule_list + 0
    ,rhs1_Resc_seq_ = 1
    ,rhs2_Resc_seq_ = 2
    ,rhs3_Resc_seq_ = 3
    ,rhs4_Resc_seq_ = 4
    ,rhs5_Resc_seq_ = 5
   ,R_Rslash_ = 570//start_of_rule_list + 2
    ,rhs1_Rslash_ = 6
   ,R_Rliteral_ = 571//start_of_rule_list + 4
    ,rhs1_Rliteral_ = 7
    ,rhs2_Rliteral_ = 8
    ,rhs3_Rliteral_ = 9
    ,rhs4_Rliteral_ = 10
    ,rhs5_Rliteral_ = 11
    ,rhs6_Rliteral_ = 12
    ,rhs7_Rliteral_ = 13
    ,rhs8_Rliteral_ = 14
    ,rhs9_Rliteral_ = 15
    ,rhs10_Rliteral_ = 16
    ,rhs11_Rliteral_ = 17
    ,rhs12_Rliteral_ = 18
   ,R_Ruhex_ = 572//start_of_rule_list + 6
    ,rhs1_Ruhex_ = 19
   ,R_Ru_ = 573//start_of_rule_list + 8
    ,rhs1_Ru_ = 20
   ,R_RU_ = 574//start_of_rule_list + 10
    ,rhs1_RU_ = 21
   ,R_Rx_ = 575//start_of_rule_list + 12
    ,rhs1_Rx_ = 22
   ,R_RUhex_ = 576//start_of_rule_list + 14
    ,rhs1_RUhex_ = 23
   ,R_Rmhex_no_ = 577//start_of_rule_list + 16
    ,rhs1_Rmhex_no_ = 24
    ,rhs2_Rmhex_no_ = 25
   ,R_Rcalc_hex_char_ = 578//start_of_rule_list + 18
    ,rhs1_Rcalc_hex_char_ = 26
   ,R_Rhex_ = 579//start_of_rule_list + 20
    ,rhs1_Rhex_ = 27
   ,R_Rhex_nos_ = 580//start_of_rule_list + 22
    ,rhs1_Rhex_nos_ = 28
    ,rhs2_Rhex_nos_ = 29
   ,R_Rhex_no_ = 581//start_of_rule_list + 24
    ,rhs1_Rhex_no_ = 30
    ,rhs2_Rhex_no_ = 31
   ,R_Rhex_no_digit_ = 582//start_of_rule_list + 26
    ,rhs1_Rhex_no_digit_ = 32
    ,rhs2_Rhex_no_digit_ = 33
    ,rhs3_Rhex_no_digit_ = 34
    ,rhs4_Rhex_no_digit_ = 35
    ,rhs5_Rhex_no_digit_ = 36
    ,rhs6_Rhex_no_digit_ = 37
    ,rhs7_Rhex_no_digit_ = 38
    ,rhs8_Rhex_no_digit_ = 39
    ,rhs9_Rhex_no_digit_ = 40
    ,rhs10_Rhex_no_digit_ = 41
   ,R_Rhex_no_letter_ = 583//start_of_rule_list + 28
    ,rhs1_Rhex_no_letter_ = 42
    ,rhs2_Rhex_no_letter_ = 43
    ,rhs3_Rhex_no_letter_ = 44
    ,rhs4_Rhex_no_letter_ = 45
    ,rhs5_Rhex_no_letter_ = 46
    ,rhs6_Rhex_no_letter_ = 47
    ,rhs7_Rhex_no_letter_ = 48
    ,rhs8_Rhex_no_letter_ = 49
    ,rhs9_Rhex_no_letter_ = 50
    ,rhs10_Rhex_no_letter_ = 51
    ,rhs11_Rhex_no_letter_ = 52
    ,rhs12_Rhex_no_letter_ = 53
   ,R_Roctal_ = 584//start_of_rule_list + 30
    ,rhs1_Roctal_ = 54
    ,rhs2_Roctal_ = 55
    ,rhs3_Roctal_ = 56
   ,R_Roctal_no_ = 585//start_of_rule_list + 32
    ,rhs1_Roctal_no_ = 57
    ,rhs2_Roctal_no_ = 58
    ,rhs3_Roctal_no_ = 59
    ,rhs4_Roctal_no_ = 60
    ,rhs5_Roctal_no_ = 61
    ,rhs6_Roctal_no_ = 62
    ,rhs7_Roctal_no_ = 63
    ,rhs8_Roctal_no_ = 64
  };
  //no of la sets = 7
  //no of states = 88
  Cesc_seq();
  ~Cesc_seq();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[65];
  
    public:
    yacco2::CAbs_lr1_sym* chk_for_overrun();
    std::string data_;
    std::string hex_data_;
    std::string octal_data_;
  
 };
struct Resc_seq;
struct Rslash;
struct Rliteral;
struct Ruhex;
struct Ru;
struct RU;
struct Rx;
struct RUhex;
struct Rmhex_no;
struct Rcalc_hex_char;
struct Rhex;
struct Rhex_nos;
struct Rhex_no;
struct Rhex_no_digit;
struct Rhex_no_letter;
struct Roctal;
struct Roctal_no;
struct Resc_seq:public yacco2::CAbs_lr1_sym {
  Resc_seq(yacco2::Parser* P);
  void op();
  public:
  void sr2();
  void sr3();
};

struct Rslash:public yacco2::CAbs_lr1_sym {
  Rslash(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rliteral:public yacco2::CAbs_lr1_sym {
  Rliteral(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
  void sr8();
  void sr9();
  void sr10();
  void sr11();
  void sr12();
};

struct Ruhex:public yacco2::CAbs_lr1_sym {
  Ruhex(yacco2::Parser* P);
  public:
};

struct Ru:public yacco2::CAbs_lr1_sym {
  Ru(yacco2::Parser* P);
  public:
  void sr1();
};

struct RU:public yacco2::CAbs_lr1_sym {
  RU(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rx:public yacco2::CAbs_lr1_sym {
  Rx(yacco2::Parser* P);
  public:
  void sr1();
};

struct RUhex:public yacco2::CAbs_lr1_sym {
  RUhex(yacco2::Parser* P);
  public:
};

struct Rmhex_no:public yacco2::CAbs_lr1_sym {
  Rmhex_no(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rcalc_hex_char:public yacco2::CAbs_lr1_sym {
  Rcalc_hex_char(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rhex:public yacco2::CAbs_lr1_sym {
  Rhex(yacco2::Parser* P);
  public:
};

struct Rhex_nos:public yacco2::CAbs_lr1_sym {
  Rhex_nos(yacco2::Parser* P);
  public:
};

struct Rhex_no:public yacco2::CAbs_lr1_sym {
  Rhex_no(yacco2::Parser* P);
  public:
};

struct Rhex_no_digit:public yacco2::CAbs_lr1_sym {
  Rhex_no_digit(yacco2::Parser* P);
  void op();
  public:
};

struct Rhex_no_letter:public yacco2::CAbs_lr1_sym {
  Rhex_no_letter(yacco2::Parser* P);
  void op();
  public:
};

struct Roctal:public yacco2::CAbs_lr1_sym {
  Roctal(yacco2::Parser* P);
  public:
};

struct Roctal_no:public yacco2::CAbs_lr1_sym {
  Roctal_no(yacco2::Parser* P);
  void op();
  public:
};

} // end of namespace

#endif
